
#include <stdio.h>
#include <ctype.h>

int Verbose = 0;

int process(char *);

#define MAXLINE 100
#define IS_SAME(s1, s2) (!strncmp((s1), (s2), sizeof(s2)-1))

main(int argc, char *argv[])
  {
    int i;
    for (i=1; (i < argc) && (argv[i][0] == '-'); i++)
      {
        if (strcmp(argv[i], "-v") == 0)
          Verbose = !Verbose;
        else if (strcmp(argv[i], "-?") == 0)
          {
            printf("General Source Preprocessor\n");
            printf("  -v: verbose mode (to stderr) (currently %s)\n",
                (Verbose)? "on" : "off");
            printf("  -?: show help screen\n");
            exit(0);
          }
        else if (strcmp(argv[i], "--") == 0)           /* end of options */
          {
            i++;
            break;
          }
      }

    if ((i != argc-1) || (argc < 2))
      {
        printf("Usage: prep [-v] [-?] filename\n");
        exit(1);
      }

    if (process(argv[i]) != 0)
      {
        fprintf(stderr, "prep encountered errors processing this file.\n");
        return 1;
      }
    else
      return 0;
  }


int process(char *name)
  {
    FILE *fp;
    char buf[MAXLINE], *tbuf;

    fp = fopen(name, "rt");
    if (!fp)
      {
        fprintf(stderr, "Can't find file %s\n", name);
        return -1;
      }

    while (fgets(buf, MAXLINE, fp))
      {
        for (tbuf = buf; isspace(*tbuf); ++tbuf);
        if (IS_SAME(tbuf, "#include"))
          {
            tbuf += sizeof("#include") - 1;
            while (isspace(*tbuf))
              ++tbuf;
            if (*tbuf == '\"')
              {
                char *temp = ++tbuf;
                while (*tbuf != '\"') tbuf++;
                *tbuf = '\0';
                tbuf = temp;
              }
            else if (*tbuf == '<')
              {
                char *temp = ++tbuf;
                while (*tbuf != '>') tbuf++;
                *tbuf = '\0';
                tbuf = temp;
              }
            if (Verbose)
              fprintf(stderr, "Including source file %s...\n", tbuf);
            process(tbuf);
          }
        else
          fputs(buf, stdout);
      }
  }

