
;; This module was coded on 12 June 2002 by Arthur O'Dwyer,
;; for use in the Day-9 Language Compiler, version one.dot.beta.
;; When assembled, this module masses 92 bytes.
;;
;; All code related to the Day-9 Compiler is freely redistributable.

;; These functions are functionally equivalent to the hard-coded
;; assembler versions found in the source library RAND.NEW.  This
;; version is just a bit smaller.

;; Note that to use this library module, the programmer must include
;; declarations for ^rand and ^randomize somewhere in the source
;; code; those variables *cannot* be declared in this (module) file,
;; because the compiler may declare them itself.

    JMP @randdone

    PAD 2, NOP
@randfirst:
    DATA = $0DCB              ; random data
@randsecond:
    DATA = $1234              ; more random data

    PAD 2, NOP
@rand_randomize:                ; initialize the RNG
    PUSH  BP
    MOV   AH, $2C
    INT   $21
    MOV   WORD PTR [@randfirst], DX
    MOV   WORD PTR [@randsecond], CX
    POP   BP
    RET

@randnext:                    ; return a number between 0 and 7FFF hex
    MOV   DI, @randfirst
    MOV   AX, WORD PTR [DI+2]
    MOV   BX, 13
    MUL   BX
    MOV   CX, AX
    MOV   AX, WORD PTR [DI]
    MUL   BX
    MOV   BX, AX
    MOV   AX, CX
    ADD   AX, DX
    SHR   AX, 9
    CWD
    SUB   AX, BX
    NEG   AX
    AND   CX, $01FF
    STOSW
    MOV   WORD PTR [DI], CX
    AND   AX, $7FFF
    RET


    PAD 2, NOP
@rand_rand:
    PUSH  @randfirst
    CALL  @randnext
    POP   CX
    RET

@randdone:
    MOV   AX, @rand_randomize              ; Assign the functions
    SHR   AX, 1                            ; to their appropriate
    MOV   WORD PTR [@_randomize], AX       ; compiler variables.
    MOV   AX, @rand_rand
    SHR   AX, 1
    MOV   WORD PTR [@_rand], AX

